#include<reg52.h>
#include <absacc.h>
#include"ds12887.h"


/* Ĵַͨ */
xdata char chSecondsChannel _at_ 0x7f00;
xdata char chMinutesChannel _at_ 0x7f02;
xdata char chHoursChannel   _at_ 0x7f04;
xdata char chDofWChannel    _at_ 0x7f06;
xdata char chDateChannel    _at_ 0x7f07;
xdata char chMonthChannel   _at_ 0x7f08;
xdata char chYearChannel    _at_ 0x7f09;
xdata char chCenturyChannel _at_ 0x7f32;
xdata char chRegA           _at_ 0x7f0a;
xdata char chRegB           _at_ 0x7f0b;
xdata char chRegC           _at_ 0x7f0c;
xdata char chRegD           _at_ 0x7f0d;



/*  */
#define CMD_START_DS12C887     0x20            /* ʱоƬ */
#define CMD_START_OSCILLATOR   0x70            /* ״̬ */
#define CMD_CLOSE_DS12C887     0x30            /* صʱоƬ */
/* еλʹûʹ */
#define MASK_SETB_SET          0x80            /* ֹˢ */
#define MASK_CLR_SET           0x7f            /* ʹˢ */
#define MASK_SETB_DM           0x04            /* ʹHEXʽ */							 
#define MASK_CLR_DM            0xfb            /* ʹBCDʽ */
#define MASK_SETB_2412         0x02            /* ʹ24Сʱģʽ */
#define MASK_CLR_2412          0xfd            /* ʹ12Сʱģʽ */
#define MASK_SETB_DSE          0x01            /* ʹʱ */
#define MASK_CLR_DSE           0xfe            /* ʹʱ */


/************************************************************* 
ܣúʱоƬ
Ӧ÷ΧʱоƬ״ʹʱõһ
ڲ
ڲ
*************************************************************/   
void StartDs12c887(void)
{
    chRegA = CMD_START_DS12C887;
}

/************************************************************* 
ܣúرʱоƬ
Ӧ÷Χһò
ڲ
ڲ
*************************************************************/   
//void CloseDs12c887(void)
//{
//    chRegA = CMD_CLOSE_DS12C887;
//}

/************************************************************* 
ܣʼDS12887
Ӧ÷Χ
ڲ
ڲ
*************************************************************/  
void InitDs12c887()
{
    chRegB = chRegB | MASK_SETB_SET;            /* ֹˢ */		
    SetDate(1,8,13); //1381
    SetTime(0,0,12); //12ʱ00
    StartDs12c887();
	chRegA=0X20;//
	chRegB=0x26;//24СʱģʽݶƸʽж
    //chRegB = chRegB & MASK_CLR_DM | MASK_SETB_2412 & MASK_CLR_DSE;  /* ʹBCDʽ24Сʱģʽʹʱ */
    chCenturyChannel = 0x21;                   /* Ϊ21 */
    chRegB = chRegB & MASK_CLR_SET;            /* ʹˢ */
}

/************************************************************* 
ܣúʱоƬȡֽ
Ӧ÷Χ
ڲ
ڲ
*************************************************************/   
unsigned char GetSeconds(void)
{
    return(chSecondsChannel);
}

/************************************************************* 
ܣúʱоƬȡֽ
Ӧ÷Χ
ڲ
ڲ
*************************************************************/   
unsigned char GetMinutes(void)
{
    return(chMinutesChannel);
}

/************************************************************* 
ܣúʱоƬȡСʱֽ
Ӧ÷Χ
ڲ
ڲ
*************************************************************/   
unsigned char GetHours(void)
{
    return(chHoursChannel);
}

/************************************************************* 
ܣúʱоƬȡֽ
Ӧ÷Χ
ڲ
ڲ
*************************************************************/   
unsigned char GetDate(void)
{
    return(chDateChannel);
}
/************************************************************* 
ܣúʱоƬȡֽ
Ӧ÷Χ
ڲ
ڲ
*************************************************************/   
unsigned char GetMonth(void)
{
    return(chMonthChannel);
}

/************************************************************* 
ܣúʱоƬȡֽ
Ӧ÷Χ
ڲ
ڲ
*************************************************************/   
unsigned char GetYear(void)
{
    return(chYearChannel);
}

/************************************************************* 
ܣúʱоƬȡֽ
Ӧ÷Χ
ڲ
ڲ
*************************************************************/   
//unsigned char GetCentury(void)
//{
//    return(chCenturyChannel);
//}    

/************************************************************* 
ܣúʱоƬʱ
Ӧ÷Χ
ڲchSecondschMinuteschHours趨ʱѹBCD
ڲ
*************************************************************/   
void SetTime(unsigned char chSeconds,unsigned char chMinutes,unsigned char chHours)
{
    chRegB = chRegB | MASK_SETB_SET;        /* ֹˢ */
    chSecondsChannel = chSeconds;
    chMinutesChannel = chMinutes;
    chHoursChannel = chHours;
    chRegB = chRegB & MASK_CLR_SET;            /* ʹˢ */
}

/************************************************************* 
ܣúʱоƬ
Ӧ÷Χ
ڲchDatechMonthchYear趨ڵѹBCD
ڲ
*************************************************************/   
void SetDate(unsigned char chDate,unsigned char chMonth,unsigned char chYear)
{
    chRegB = chRegB | MASK_SETB_SET;        /* ֹˢ */
    chDateChannel = chDate;
    chMonthChannel = chMonth;
    chYearChannel = chYear;
    chRegB = chRegB & MASK_CLR_SET;         /* ʹˢ */

}

